#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;



namespace FilterTemplate {

	public ref class SettingsForm : public System::Windows::Forms::Form
	{
	public:
		filtersettings* FilterSetting;
		bool FilterCancelled, initing;

	private: 
		System::Windows::Forms::Button^			ButtonApply;
		System::Windows::Forms::Button^			ButtonCancel;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexRemove;
		System::Windows::Forms::HScrollBar^		ScrollBarIndexNew;
		System::Windows::Forms::HScrollBar^		ScrollBarBlobSizeLimit;
		System::Windows::Forms::Label^			LabelIndexRemove;
		System::Windows::Forms::Label^			LabelIndexNew;
		System::Windows::Forms::Label^			LabelBlobSizeLimit;
		System::Windows::Forms::Label^			label1;
		System::Windows::Forms::Label^			label2;
		System::Windows::Forms::Label^			label3;
		System::Windows::Forms::PictureBox^		PictureBoxRemoveColor;
		System::Windows::Forms::PictureBox^		PictureBoxNewColor;
		System::ComponentModel::IContainer^		components;

	public:
		SettingsForm(filtersettings* fs)
		{
			InitializeComponent();

			FilterSetting = fs;
			initing = true;

			ScrollBarIndexRemove->Minimum   = 0;
			ScrollBarIndexRemove->Maximum   = 255;
			ScrollBarIndexRemove->Value     = fs->blob_index_remove;

			ScrollBarIndexNew->Minimum      = 0;
			ScrollBarIndexNew->Maximum      = 255;
			ScrollBarIndexNew->Value        = fs->blob_index_new;

			ScrollBarBlobSizeLimit->Minimum = 10;
			ScrollBarBlobSizeLimit->Maximum = 10000;
			if (fs->blob_index_size_limit < 10)    fs->blob_index_size_limit = 10;
			if (fs->blob_index_size_limit > 10000) fs->blob_index_size_limit = 10000;
			ScrollBarBlobSizeLimit->Value   = fs->blob_index_size_limit;

			initing = false;
			FilterCancelled = true;
		}

	protected:

		~SettingsForm()
		{
			if (components)
			{
				delete components;
			}
		}


#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			this->ButtonApply = (gcnew System::Windows::Forms::Button());
			this->ButtonCancel = (gcnew System::Windows::Forms::Button());
			this->ScrollBarIndexRemove = (gcnew System::Windows::Forms::HScrollBar());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->LabelIndexRemove = (gcnew System::Windows::Forms::Label());
			this->LabelIndexNew = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarIndexNew = (gcnew System::Windows::Forms::HScrollBar());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->ScrollBarBlobSizeLimit = (gcnew System::Windows::Forms::HScrollBar());
			this->LabelBlobSizeLimit = (gcnew System::Windows::Forms::Label());
			this->PictureBoxRemoveColor = (gcnew System::Windows::Forms::PictureBox());
			this->PictureBoxNewColor = (gcnew System::Windows::Forms::PictureBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxRemoveColor))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->BeginInit();
			this->SuspendLayout();
			// 
			// ButtonApply
			// 
			this->ButtonApply->Location = System::Drawing::Point(112, 152);
			this->ButtonApply->Name = L"ButtonApply";
			this->ButtonApply->Size = System::Drawing::Size(75, 23);
			this->ButtonApply->TabIndex = 2;
			this->ButtonApply->Text = L"Apply";
			this->ButtonApply->UseVisualStyleBackColor = true;
			this->ButtonApply->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonApply_Click);
			// 
			// ButtonCancel
			// 
			this->ButtonCancel->Location = System::Drawing::Point(193, 152);
			this->ButtonCancel->Name = L"ButtonCancel";
			this->ButtonCancel->Size = System::Drawing::Size(75, 23);
			this->ButtonCancel->TabIndex = 3;
			this->ButtonCancel->Text = L"Cancel";
			this->ButtonCancel->UseVisualStyleBackColor = true;
			this->ButtonCancel->Click += gcnew System::EventHandler(this, &SettingsForm::ButtonCancel_Click);
			// 
			// ScrollBarIndexRemove
			// 
			this->ScrollBarIndexRemove->LargeChange = 1;
			this->ScrollBarIndexRemove->Location = System::Drawing::Point(51, 76);
			this->ScrollBarIndexRemove->Maximum = 255;
			this->ScrollBarIndexRemove->Name = L"ScrollBarIndexRemove";
			this->ScrollBarIndexRemove->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexRemove->TabIndex = 8;
			this->ScrollBarIndexRemove->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexRemove->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->ForeColor = System::Drawing::Color::White;
			this->label2->Location = System::Drawing::Point(48, 63);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(165, 13);
			this->label2->TabIndex = 11;
			this->label2->Text = L"Eltvoltand blobok szn-indexe:";
			// 
			// LabelIndexRemove
			// 
			this->LabelIndexRemove->AutoSize = true;
			this->LabelIndexRemove->ForeColor = System::Drawing::Color::White;
			this->LabelIndexRemove->Location = System::Drawing::Point(304, 80);
			this->LabelIndexRemove->Name = L"LabelIndexRemove";
			this->LabelIndexRemove->Size = System::Drawing::Size(13, 13);
			this->LabelIndexRemove->TabIndex = 14;
			this->LabelIndexRemove->Text = L"0";
			// 
			// LabelIndexNew
			// 
			this->LabelIndexNew->AutoSize = true;
			this->LabelIndexNew->ForeColor = System::Drawing::Color::White;
			this->LabelIndexNew->Location = System::Drawing::Point(304, 127);
			this->LabelIndexNew->Name = L"LabelIndexNew";
			this->LabelIndexNew->Size = System::Drawing::Size(13, 13);
			this->LabelIndexNew->TabIndex = 17;
			this->LabelIndexNew->Text = L"0";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->ForeColor = System::Drawing::Color::White;
			this->label3->Location = System::Drawing::Point(48, 110);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(71, 13);
			this->label3->TabIndex = 16;
			this->label3->Text = L"j szn-index:";
			// 
			// ScrollBarIndexNew
			// 
			this->ScrollBarIndexNew->LargeChange = 1;
			this->ScrollBarIndexNew->Location = System::Drawing::Point(51, 123);
			this->ScrollBarIndexNew->Maximum = 255;
			this->ScrollBarIndexNew->Name = L"ScrollBarIndexNew";
			this->ScrollBarIndexNew->Size = System::Drawing::Size(250, 17);
			this->ScrollBarIndexNew->TabIndex = 15;
			this->ScrollBarIndexNew->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarIndexNew->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->ForeColor = System::Drawing::Color::White;
			this->label1->Location = System::Drawing::Point(48, 9);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(190, 13);
			this->label1->TabIndex = 18;
			this->label1->Text = L"Eltvoltand blobok maximlis mrete:";
			// 
			// ScrollBarBlobSizeLimit
			// 
			this->ScrollBarBlobSizeLimit->LargeChange = 1;
			this->ScrollBarBlobSizeLimit->Location = System::Drawing::Point(51, 22);
			this->ScrollBarBlobSizeLimit->Maximum = 10000;
			this->ScrollBarBlobSizeLimit->Minimum = 10;
			this->ScrollBarBlobSizeLimit->Name = L"ScrollBarBlobSizeLimit";
			this->ScrollBarBlobSizeLimit->Size = System::Drawing::Size(250, 17);
			this->ScrollBarBlobSizeLimit->TabIndex = 19;
			this->ScrollBarBlobSizeLimit->Value = 10;
			this->ScrollBarBlobSizeLimit->ValueChanged += gcnew System::EventHandler(this, &SettingsForm::Scroll_ValueChanged);
			this->ScrollBarBlobSizeLimit->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &SettingsForm::Scroll_Change);
			// 
			// LabelBlobSizeLimit
			// 
			this->LabelBlobSizeLimit->AutoSize = true;
			this->LabelBlobSizeLimit->ForeColor = System::Drawing::Color::White;
			this->LabelBlobSizeLimit->Location = System::Drawing::Point(304, 26);
			this->LabelBlobSizeLimit->Name = L"LabelBlobSizeLimit";
			this->LabelBlobSizeLimit->Size = System::Drawing::Size(19, 13);
			this->LabelBlobSizeLimit->TabIndex = 20;
			this->LabelBlobSizeLimit->Text = L"10";
			// 
			// PictureBoxRemoveColor
			// 
			this->PictureBoxRemoveColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxRemoveColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxRemoveColor->Location = System::Drawing::Point(12, 76);
			this->PictureBoxRemoveColor->Name = L"PictureBoxRemoveColor";
			this->PictureBoxRemoveColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxRemoveColor->TabIndex = 21;
			this->PictureBoxRemoveColor->TabStop = false;
			// 
			// PictureBoxNewColor
			// 
			this->PictureBoxNewColor->BackColor = System::Drawing::Color::White;
			this->PictureBoxNewColor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->PictureBoxNewColor->Location = System::Drawing::Point(12, 123);
			this->PictureBoxNewColor->Name = L"PictureBoxNewColor";
			this->PictureBoxNewColor->Size = System::Drawing::Size(31, 17);
			this->PictureBoxNewColor->TabIndex = 22;
			this->PictureBoxNewColor->TabStop = false;
			// 
			// SettingsForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::SteelBlue;
			this->ClientSize = System::Drawing::Size(337, 187);
			this->Controls->Add(this->PictureBoxNewColor);
			this->Controls->Add(this->PictureBoxRemoveColor);
			this->Controls->Add(this->LabelBlobSizeLimit);
			this->Controls->Add(this->ScrollBarBlobSizeLimit);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->LabelIndexNew);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->ScrollBarIndexNew);
			this->Controls->Add(this->LabelIndexRemove);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->ScrollBarIndexRemove);
			this->Controls->Add(this->ButtonCancel);
			this->Controls->Add(this->ButtonApply);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"SettingsForm";
			this->ShowIcon = false;
			this->ShowInTaskbar = false;
			this->Text = L"Kis foltok eltvoltsa";
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxRemoveColor))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxNewColor))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
		System::Void ButtonApply_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			FilterCancelled = false;
			this->Close();
		}


		System::Void ButtonCancel_Click(System::Object^  sender, System::EventArgs^  e) { this->Close(); }

		System::Void Scroll_Change(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e) 
		{
			if (!initing)
			{
				FilterSetting->blob_index_remove     = ScrollBarIndexRemove->Value;
				FilterSetting->blob_index_new        = ScrollBarIndexNew->Value;
				FilterSetting->blob_index_size_limit = ScrollBarBlobSizeLimit->Value;
			}

			LabelIndexRemove->Text               = ScrollBarIndexRemove->Value.ToString();
			LabelIndexNew->Text                  = ScrollBarIndexNew->Value.ToString();
			LabelBlobSizeLimit->Text             = ScrollBarBlobSizeLimit->Value.ToString();

			int r, g, b, index;

			index = FilterSetting->blob_index_remove;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxRemoveColor->BackColor     = Color::FromArgb(r, g, b);

			index = FilterSetting->blob_index_new;
			b = ((byte*)(FilterSetting->palette256 + index))[0];
			g = ((byte*)(FilterSetting->palette256 + index))[1];
			r = ((byte*)(FilterSetting->palette256 + index))[2];
			PictureBoxNewColor->BackColor     = Color::FromArgb(r, g, b);
		}

		System::Void Scroll_ValueChanged(System::Object^  sender, System::EventArgs^  e) { Scroll_Change(nullptr, nullptr); }
};
}
